// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_DATAENTRY_H
#define _LIBGNOMEDBMM_DATAENTRY_H


#include <glibmm.h>

// -*- C++ -*- // 

/* dataentry.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 

#include <libgdamm/dict.h>
#include <libgdamm/value.h>
#include <libgdamm/datahandler.h>
#include <gtkmm/widget.h>

#include <libgnomedb/gnome-db-data-entry.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbDataEntry GnomeDbDataEntry;
typedef struct _GnomeDbDataEntryClass GnomeDbDataEntryClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class DataEntry_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Base class which provides the user with specific widgets to manipulate data.
 * This interface is inherited by widgets to enable users to manipulate data of different types. 
 * Such widgets are created by objects implementing the Gda::DataHandler interface.
 */

class DataEntry : public Glib::Interface
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DataEntry CppObjectType;
  typedef DataEntry_Class CppClassType;
  typedef GnomeDbDataEntry BaseObjectType;
  typedef GnomeDbDataEntryIface BaseClassType;

private:
  friend class DataEntry_Class;
  static CppClassType dataentry_class_;

  // noncopyable
  DataEntry(const DataEntry&);
  DataEntry& operator=(const DataEntry&);

protected:
  DataEntry(); // you must derive from this class
  explicit DataEntry(GnomeDbDataEntry* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~DataEntry();

  static void add_interface(GType gtype_implementer);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GnomeDbDataEntry*       gobj()       { return reinterpret_cast<GnomeDbDataEntry*>(gobject_); }

  ///Provides access to the underlying C GObject.  
  const GnomeDbDataEntry* gobj() const { return reinterpret_cast<GnomeDbDataEntry*>(gobject_); }

private:


protected:
/* TODO, when the linker error (use of extern "C") is fixed in the next libgnomedb tarball:

  //The C function returns a GnomeDbDataEntry*, which would be nice to return, 
  //but we would have to return it as a Glib::RefPtr, 
  //but it would then be used as a Widget, which is used via a regular pointer.
  #m4 _CONVERSION(`GnomeDbDataEntry*',`Gtk::Widget*',`Glib::wrap(GTK_WIDGET($3))')
  _WRAP_METHOD(static Gtk::Widget* create_suitable_data_entry(const Glib::RefPtr<Gda::Dict>& dict, GType type, const std::string& plugin_name), gnome_db_util_new_data_entry)
  static Gtk::Widget* create_suitable_data_entry(const Glib::RefPtr<Gda::Dict>& dict, GType type);
*/

public:
  
  /** Sets the type of value the GnomeDbDataEntry will handle. The type must be compatible with what
   * the widget can handle.
   */
  void set_value_type(GType type);
  
  /** Fetch the type of data the GnomeDbDataEntry handles
   * @return The GType type.
   */
  GType get_value_type() const;
  
  
  /** Push a value into the GnomeDbDataEntry. The value parameter must either be:
   * - <tt>0</tt> or of type GDA_TYPE_<tt>0</tt>, or
   * - of type specified using gnome_db_data_entry_set_value_type.
   */
  void set_value(const Gda::Value& value);

  
  /** Fetch the value held in the GnomeDbDataEntry widget. If the value is set to <tt>0</tt>,
   * the returned value is of type GDA_TYPE_<tt>0</tt>. If the value is set to default,
   * then the returned value is of type GDA_TYPE_<tt>0</tt> or is the default value if it
   * has been provided to the widget (and is of the same type as the one provided by @a de ).
   * @return A new GValue.
   */

   Gda::Value get_value() const;
  
  
  /** Push a value into the GnomeDbDataEntry in the same way as set_value() but
   * also sets this value as the original value.
   */
  void set_value_orig(const Gda::Value& value);

  
  /** Fetch the original value held in the GnomeDbDataEntry widget
   * @return The GValue.
   */

  Gda::Value get_value_orig() const;

  
  /** Tells that the current value in @a de  is to be considered as the original value
   */
  void set_current_as_orig();

  
  /** Sets the default value for the GnomeDbDataEntry which gets displayed when the
   * user forces the default value. If it is not set then it is set to type GDA_TYPE_<tt>0</tt>.
   * The value parameter must either be:
   * - <tt>0</tt> or of type GDA_TYPE_<tt>0</tt>, or
   * - of type specified using gnome_db_data_entry_set_value_type.
   */
  void set_value_default(const Gda::Value& value);
  
  
  /** Fetch the GdaDataHandler the GnomeDbDataEntry is using
   * @return The GdaDataHandler object.
   */
  Glib::RefPtr<Gda::DataHandler> get_handler();
  
  /** Fetch the GdaDataHandler the GnomeDbDataEntry is using
   * @return The GdaDataHandler object.
   */
  Glib::RefPtr<const Gda::DataHandler> get_handler() const;
  
  
  /** Retreives the parameters of the GnomeDbDataEntry widget.
   * @return The OR'ed bits corresponding to the attributes.
   */
  Gda::ValueAttribute get_attributes() const;
  
  /** Sets the parameters of the GnomeDbDataEntry. Only the attributes corresponding to the
   * mask are set, the other ones are ignored.
   * @param attrs The attributes to set (OR'ed between them).
   * @param mask The mask corresponding to the considered attributes.
   */
  void set_attributes(Gda::ValueAttribute attrs, Gda::ValueAttribute mask);
  
  
  /** Used for the layout of the widget in containers.
   * @return <tt>true</tt> if the widget should expand.
   */
  bool get_expand_in_layout() const; //We rename, adding the get prefix, to make it clearer.
  
  /** Set if @a de  can be modified or not by the user
   */
  void set_editable(bool editable = true);
  
  void grab_focus();

  // TODO: I don't think this should throw an exception in C++
  
#ifdef GLIBMM_EXCEPTIONS_ENABLED
  bool is_contents_valid() const;
#else
  bool is_contents_valid(std::auto_ptr<Glib::Error>& error) const;
#endif //GLIBMM_EXCEPTIONS_ENABLED
;
  
  
  /**
   * @par Prototype:
   * <tt>void %contents_modified()</tt>
   */

  Glib::SignalProxy0< void > signal_contents_modified();

  
  /**
   * @par Prototype:
   * <tt>void %contents_activated()</tt>
   */

  Glib::SignalProxy0< void > signal_contents_activated();

  
  /**
   * @par Prototype:
   * <tt>void %status_changed()</tt>
   */

  Glib::SignalProxy0< void > signal_status_changed();


protected:
  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void set_value_type_vfunc(GType type);
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual GType get_value_type_vfunc();
#endif //GLIBMM_VFUNCS_ENABLED


  //TODO: _WRAP_VFUNC(void set_value(const Gda::Value& value), set_value)
  //TODO: _WRAP_VFUNC(Gda::Value get_value() const, get_value)
  
  //TODO: _WRAP_VFUNC(void set_value_orig(const Gda::Value& value), set_value_orig)
  //TODO: _WRAP_VFUNC(const Gda::Value& get_value_orig(), get_value_orig)

  //TODO: _WRAP_VFUNC(void set_value_default(const Gda::Value& value), set_value_default)
  
  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void set_attributes_vfunc(Gda::ValueAttribute attributes, Gda::ValueAttribute mask);
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual Gda::ValueAttribute get_attributes_vfunc() const;
#endif //GLIBMM_VFUNCS_ENABLED

  
  // _WRAP_VFUNC(Gda::DataHandler& get_handler(), get_handler)
  
  //TODO: Is this a get method? If so, if should be const, and maybe renamed in the C API:
  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual bool expand_in_row_vfunc();
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void set_editable_vfunc(bool editable);
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void grab_focus_vfunc();
#endif //GLIBMM_VFUNCS_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_contents_modified();
  virtual void on_contents_activated();
  virtual void on_status_changed();
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Db

} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::DataEntry
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Glib::RefPtr<Gnome::Db::DataEntry> wrap(GnomeDbDataEntry* object, bool take_copy = false);

} // namespace Glib


#endif /* _LIBGNOMEDBMM_DATAENTRY_H */

