// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_DSNSPEC_H
#define _LIBGNOMEDBMM_DSNSPEC_H


#include <glibmm.h>

// -*- C++ -*- // 

/* dsnspec.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 

#include <gtkmm/box.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbDsnSpec GnomeDbDsnSpec;
typedef struct _GnomeDbDsnSpecClass GnomeDbDsnSpecClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class DsnSpec_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** A form to enter information required to open a connection.
 * This widget contains a form to display and edit the information required by a provider to open a connection.
 *
 * @ingroup DbWidgets
 */

class DsnSpec : public Gtk::VBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef DsnSpec CppObjectType;
  typedef DsnSpec_Class CppClassType;
  typedef GnomeDbDsnSpec BaseObjectType;
  typedef GnomeDbDsnSpecClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~DsnSpec();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class DsnSpec_Class;
  static CppClassType dsnspec_class_;

  // noncopyable
  DsnSpec(const DsnSpec&);
  DsnSpec& operator=(const DsnSpec&);

protected:
  explicit DsnSpec(const Glib::ConstructParams& construct_params);
  explicit DsnSpec(GnomeDbDsnSpec* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbDsnSpec*       gobj()       { return reinterpret_cast<GnomeDbDsnSpec*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbDsnSpec* gobj() const { return reinterpret_cast<GnomeDbDsnSpec*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_changed();
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
  public:
    explicit DsnSpec(const Glib::ustring& provider);
    
    
  /** Updates the displayed fields in @a spec  to represent the required
   * and possible arguments that a connection to a database through 
   *  @a provider  would require
   * @param provider The provider to be used.
   */
  void set_provider(const Glib::ustring& provider);

    
  bool is_valid() const;
    
  /** Get the currently displayed provider's specific
   * connection string
   * @return A new string, or <tt>0</tt> if no provider have been specified.
   */
  Glib::ustring get_specs() const;
    
  /** Sets the connection string to be displayed in the widget
   */
  void set_specs(const Glib::ustring& dsn);

    #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_provider() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_provider() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  /**
   * @par Prototype:
   * <tt>void %changed()</tt>
   */

  Glib::SignalProxy0< void > signal_changed();


};

} // namespace Db

} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::DsnSpec
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::DsnSpec* wrap(GnomeDbDsnSpec* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_DSNSPEC_H */

