// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_FINDDIALOG_H
#define _LIBGNOMEDBMM_FINDDIALOG_H


#include <glibmm.h>

// -*- C++ -*- // 

/* finddialog.h
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/dialog.h>
#include <libgdamm/datamodel.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbFindDialog GnomeDbFindDialog;
typedef struct _GnomeDbFindDialogClass GnomeDbFindDialogClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class FindDialog_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** A dialog to enter a string to search in a Gda::DataModel.
 *
 * @ingroup DbDialogs
 */

class FindDialog : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef FindDialog CppObjectType;
  typedef FindDialog_Class CppClassType;
  typedef GnomeDbFindDialog BaseObjectType;
  typedef GnomeDbFindDialogClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~FindDialog();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class FindDialog_Class;
  static CppClassType finddialog_class_;

  // noncopyable
  FindDialog(const FindDialog&);
  FindDialog& operator=(const FindDialog&);

protected:
  explicit FindDialog(const Glib::ConstructParams& construct_params);
  explicit FindDialog(GnomeDbFindDialog* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbFindDialog*       gobj()       { return reinterpret_cast<GnomeDbFindDialog*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbFindDialog* gobj() const { return reinterpret_cast<GnomeDbFindDialog*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:


public:
  explicit FindDialog(const Glib::ustring& title);

  /** Creates a new FindDialog and adds the fields of the @a model to the Fields combo.
   *
   * @param title The title of the dialog.
   * @param model A Gda::DataModel.
   */
  explicit FindDialog(const Glib::ustring& title, const Glib::RefPtr<Gda::DataModel>& model);

  
  /** Shows the @a dialog  to the user and wait for his/her input.
   * @return True if the user clicks "find", false otherwise.
   */
  bool run();
  
  /** Adds @a field  to the Fields combo.
   * @param field The field's name.
   */
  void add_field(const Glib::ustring& field);
  
  /** Adds all the fields of @a dm  into the Fields combo.
   * @param dm A Gda::DataModel.
   */
  void add_fields_from_model(const Glib::RefPtr<Gda::DataModel>& dm);
  
  /** Gets the current search text in @a dialog .
   * @return Text to find.
   */
  Glib::ustring get_text() const;
  
  /** Gets the currently selected field in @a dialog .
   * @return Name of the selected field.
   */
  Glib::ustring get_field() const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_field() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_text() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::FindDialog
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::FindDialog* wrap(GnomeDbFindDialog* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_FINDDIALOG_H */

