// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_GRID_H
#define _LIBGNOMEDBMM_GRID_H


#include <glibmm.h>

// -*- C++ -*- // 

/* grid.h
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/box.h>
#include <libgdamm/datamodel.h>
#include <libgnomedbmm/rawgrid.h>
#include <libgnomedbmm/datawidgetinfo.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbGrid GnomeDbGrid;
typedef struct _GnomeDbGridClass GnomeDbGridClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class Grid_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Database grid widget to display and modify data in a Gda::DataModel, with command buttons and indicators.
 *
 * @ingroup DbWidgets
 */

class Grid : public Gtk::VBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Grid CppObjectType;
  typedef Grid_Class CppClassType;
  typedef GnomeDbGrid BaseObjectType;
  typedef GnomeDbGridClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Grid();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Grid_Class;
  static CppClassType grid_class_;

  // noncopyable
  Grid(const Grid&);
  Grid& operator=(const Grid&);

protected:
  explicit Grid(const Glib::ConstructParams& construct_params);
  explicit Grid(GnomeDbGrid* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbGrid*       gobj()       { return reinterpret_cast<GnomeDbGrid*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbGrid* gobj() const { return reinterpret_cast<GnomeDbGrid*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:


public:
  explicit Grid(const Glib::RefPtr<Gda::DataModel>& model);

  #ifndef DOXYGEN_SHOULD_SKIP_THIS
  // TODO: I wonder why there is no such thing in glibmm.
  // Is this really that uncommon? armin.
  struct IntTraits
  {
    typedef int  CppType;
    typedef gpointer CType;
    typedef gpointer CTypeNonConst;

    static CType   to_c_type      (const CppType& obj) { return GINT_TO_POINTER(obj); }
    static CType   to_c_type      (const CType&   obj) { return GINT_TO_POINTER(obj); }
    static CppType to_cpp_type    (const CType&   obj) { return GPOINTER_TO_INT(obj); }
    static void    release_c_type (const CType&)       {}
  };
  #endif //DOXYGEN_SHOULD_SKIP_THIS

  typedef Glib::ListHandle<int, IntTraits> IntListHandle;

  // Fully qualify the IntListHandle type here to make it available in
  // the generated code.
   

  /** Returns: a new list, should be freed (by calling g_list_free) when no longer needed.
   * @return A new list, should be freed (by calling g_list_free) when no longer needed.
   */
  Grid::IntListHandle get_selection() const;

  
  /** 
   */
  void set_sample_size(int sample_size);

  // This is just convenience API to provide access to the raw form property
  // in a cleaner way than calling property_raw_form and that also works
  // when glibmm has not been compiled with support for properties. In
  // contrast to other properties, access to this one is required to
  // perform some tasks (like restricting a field's possible values).

  /** Provides access to the underlaying @a RawGrid.
   */
  RawGrid* get_raw_grid();

  /** Provides access to the underlaying @a RawGrid.
   */
  const RawGrid* get_raw_grid() const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<RawGrid*> property_raw_grid() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<DataWidgetInfo*> property_widget_info() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gda::DataModel> > property_model() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::Grid
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::Grid* wrap(GnomeDbGrid* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_GRID_H */

