// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_LOGIN_H
#define _LIBGNOMEDBMM_LOGIN_H


#include <glibmm.h>

// -*- C++ -*- // 

/* login.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 

#include <gtkmm/box.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbLogin GnomeDbLogin;
typedef struct _GnomeDbLoginClass GnomeDbLoginClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class Login_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Login widget.
 *
 * @ingroup DbWidgets
 */

class Login : public Gtk::VBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Login CppObjectType;
  typedef Login_Class CppClassType;
  typedef GnomeDbLogin BaseObjectType;
  typedef GnomeDbLoginClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Login();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Login_Class;
  static CppClassType login_class_;

  // noncopyable
  Login(const Login&);
  Login& operator=(const Login&);

protected:
  explicit Login(const Glib::ConstructParams& construct_params);
  explicit Login(GnomeDbLogin* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbLogin*       gobj()       { return reinterpret_cast<GnomeDbLogin*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbLogin* gobj() const { return reinterpret_cast<GnomeDbLogin*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
  public:
    Login();
    
    
  /** 
   */
  Glib::ustring get_dsn() const;
    
  /** Set the data source name on the given Gnome::DbLogin widget.
   * @param dsn Data source name.
   */
  void set_dsn(const Glib::ustring& dsn);

    
  /** Get the value currently entered in the username text entry.
   * @return The username being entered in the login widget.
   */
  Glib::ustring get_username() const;
    
  /** Sets the user name to be displayed in the given Gnome::DbLogin widget.
   * @param username Username to display in the widget.
   */
  void set_username(const Glib::ustring& username);
    
    
  /** 
   */
  Glib::ustring get_password() const;
    
  /** Sets the password to be displayed in the given Gnome::DbLogin widget.
   * @param password Password to display in the widget.
   */
  void set_password(const Glib::ustring& password);
    
    
  /** Enable/disable the button allowing the user to create new data sources
   * from the login widget. This button is disabled by default, and when enabled,
   * allows the user to start the database properties configuration applet.
   * @param enable Flag to enable/disable the button.
   */
  void set_enable_create_button(bool enable = true);
    
  /** Tell if the the button allowing the user to create new data sources is shown
   * or not. This button is disabled by default,
   * @return <tt>true</tt> if the button is shown.
   */
  bool get_enable_create_button() const;
    
    
  /** Show/hide the combo box which allows to select the datasource to log into.
   */
  void set_show_dsn_selector(bool enable = true);
    
  /** Tells if the combo box which allows to select the datasource to log into is shown
   * or not.
   * @return <tt>true</tt> if the combo box is shown.
   */
  bool get_show_dsn_selector() const;
    
    #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_dsn() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


    #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_hiding_button() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_hiding_button() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

    #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_hiding_dsn() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_hiding_dsn() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

    #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_username() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


    #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_password() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} // namespace Db

} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::Login
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::Login* wrap(GnomeDbLogin* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_LOGIN_H */

