// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_TRANSACTIONSTATUS_H
#define _LIBGNOMEDBMM_TRANSACTIONSTATUS_H


#include <glibmm.h>

// -*- C++ -*- // 

/* transactionstatus.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 

#include <gtkmm/box.h>
#include <gtkmm/window.h>
#include <libgdamm/connection.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbTransactionStatus GnomeDbTransactionStatus;
typedef struct _GnomeDbTransactionStatusClass GnomeDbTransactionStatusClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class TransactionStatus_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Displays the transaction status of a connection.
 * This widget displays the contents of a Gda::TransactionStatus object which represents the "transactional status" 
 * of a connection (it tells whether a transaction has been started, if there are savepoints, etc).
 *
 * This widget also allows the user to begin, commit or rollback transactions and to add, rollback or remove savepoints. 
 *
 * @ingroup DbWidgets
 */

class TransactionStatus : public Gtk::VBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef TransactionStatus CppObjectType;
  typedef TransactionStatus_Class CppClassType;
  typedef GnomeDbTransactionStatus BaseObjectType;
  typedef GnomeDbTransactionStatusClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~TransactionStatus();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class TransactionStatus_Class;
  static CppClassType transactionstatus_class_;

  // noncopyable
  TransactionStatus(const TransactionStatus&);
  TransactionStatus& operator=(const TransactionStatus&);

protected:
  explicit TransactionStatus(const Glib::ConstructParams& construct_params);
  explicit TransactionStatus(GnomeDbTransactionStatus* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbTransactionStatus*       gobj()       { return reinterpret_cast<GnomeDbTransactionStatus*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbTransactionStatus* gobj() const { return reinterpret_cast<GnomeDbTransactionStatus*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
  public:
    
    explicit TransactionStatus(const Glib::RefPtr<Gda::Connection>& connection);


};

} // namespace Db

} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::TransactionStatus
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::TransactionStatus* wrap(GnomeDbTransactionStatus* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_TRANSACTIONSTATUS_H */

